/* ControlKey.c generated by valac 0.56.13, the Vala compiler
 * generated from ControlKey.vala, do not modify */

/*
 * Copyright (c) 2022 Andrew Vojak (https://avojak.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Andrew Vojak <andrew.vojak@gmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <cairo-gobject.h>
#include <granite.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>

#define CONSTANTS_APP_ID "com.github.avojak.warble"
#define WARBLE_WIDGETS_CONTROL_KEY_KEY_IMAGE_WIDTH 48
#define WARBLE_WIDGETS_CONTROL_KEY_KEY_IMAGE_HEIGHT 32
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define WARBLE_WIDGETS_TYPE_CONTROL_KEY (warble_widgets_control_key_get_type ())
#define WARBLE_WIDGETS_CONTROL_KEY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WARBLE_WIDGETS_TYPE_CONTROL_KEY, WarbleWidgetsControlKey))
#define WARBLE_WIDGETS_CONTROL_KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WARBLE_WIDGETS_TYPE_CONTROL_KEY, WarbleWidgetsControlKeyClass))
#define WARBLE_WIDGETS_IS_CONTROL_KEY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WARBLE_WIDGETS_TYPE_CONTROL_KEY))
#define WARBLE_WIDGETS_IS_CONTROL_KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WARBLE_WIDGETS_TYPE_CONTROL_KEY))
#define WARBLE_WIDGETS_CONTROL_KEY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WARBLE_WIDGETS_TYPE_CONTROL_KEY, WarbleWidgetsControlKeyClass))

typedef struct _WarbleWidgetsControlKey WarbleWidgetsControlKey;
typedef struct _WarbleWidgetsControlKeyClass WarbleWidgetsControlKeyClass;
typedef struct _WarbleWidgetsControlKeyPrivate WarbleWidgetsControlKeyPrivate;

#define WARBLE_WIDGETS_CONTROL_KEY_TYPE_KEY_IMAGE (warble_widgets_control_key_key_image_get_type ())
#define WARBLE_WIDGETS_CONTROL_KEY_KEY_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WARBLE_WIDGETS_CONTROL_KEY_TYPE_KEY_IMAGE, WarbleWidgetsControlKeyKeyImage))
#define WARBLE_WIDGETS_CONTROL_KEY_KEY_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WARBLE_WIDGETS_CONTROL_KEY_TYPE_KEY_IMAGE, WarbleWidgetsControlKeyKeyImageClass))
#define WARBLE_WIDGETS_CONTROL_KEY_IS_KEY_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WARBLE_WIDGETS_CONTROL_KEY_TYPE_KEY_IMAGE))
#define WARBLE_WIDGETS_CONTROL_KEY_IS_KEY_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WARBLE_WIDGETS_CONTROL_KEY_TYPE_KEY_IMAGE))
#define WARBLE_WIDGETS_CONTROL_KEY_KEY_IMAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WARBLE_WIDGETS_CONTROL_KEY_TYPE_KEY_IMAGE, WarbleWidgetsControlKeyKeyImageClass))

typedef struct _WarbleWidgetsControlKeyKeyImage WarbleWidgetsControlKeyKeyImage;
typedef struct _WarbleWidgetsControlKeyKeyImageClass WarbleWidgetsControlKeyKeyImageClass;
enum  {
	WARBLE_WIDGETS_CONTROL_KEY_0_PROPERTY,
	WARBLE_WIDGETS_CONTROL_KEY_TEXT_PROPERTY,
	WARBLE_WIDGETS_CONTROL_KEY_ICON_NAME_PROPERTY,
	WARBLE_WIDGETS_CONTROL_KEY_NUM_PROPERTIES
};
static GParamSpec* warble_widgets_control_key_properties[WARBLE_WIDGETS_CONTROL_KEY_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _WarbleWidgetsControlKeyKeyImagePrivate WarbleWidgetsControlKeyKeyImagePrivate;
enum  {
	WARBLE_WIDGETS_CONTROL_KEY_KEY_IMAGE_0_PROPERTY,
	WARBLE_WIDGETS_CONTROL_KEY_KEY_IMAGE_TEXT_PROPERTY,
	WARBLE_WIDGETS_CONTROL_KEY_KEY_IMAGE_Y_OFFSET_PROPERTY,
	WARBLE_WIDGETS_CONTROL_KEY_KEY_IMAGE_NUM_PROPERTIES
};
static GParamSpec* warble_widgets_control_key_key_image_properties[WARBLE_WIDGETS_CONTROL_KEY_KEY_IMAGE_NUM_PROPERTIES];
typedef enum  {
	WARBLE_COLOR_PALETTE_TEXT_COLOR
} WarbleColorPalette;

#define WARBLE_TYPE_COLOR_PALETTE (warble_color_palette_get_type ())
enum  {
	WARBLE_WIDGETS_CONTROL_KEY_CLICKED_SIGNAL,
	WARBLE_WIDGETS_CONTROL_KEY_NUM_SIGNALS
};
static guint warble_widgets_control_key_signals[WARBLE_WIDGETS_CONTROL_KEY_NUM_SIGNALS] = {0};

struct _WarbleWidgetsControlKey {
	GtkEventBox parent_instance;
	WarbleWidgetsControlKeyPrivate * priv;
};

struct _WarbleWidgetsControlKeyClass {
	GtkEventBoxClass parent_class;
};

struct _WarbleWidgetsControlKeyPrivate {
	gchar* _text;
	gchar* _icon_name;
	WarbleWidgetsControlKeyKeyImage* key;
	GtkImage* overlay_icon;
	gboolean is_pressed;
};

struct _WarbleWidgetsControlKeyKeyImage {
	GtkImage parent_instance;
	WarbleWidgetsControlKeyKeyImagePrivate * priv;
};

struct _WarbleWidgetsControlKeyKeyImageClass {
	GtkImageClass parent_class;
};

struct _WarbleWidgetsControlKeyKeyImagePrivate {
	gchar* _text;
	gint _y_offset;
};

static gint WarbleWidgetsControlKey_private_offset;
static gpointer warble_widgets_control_key_parent_class = NULL;
static GtkCssProvider* warble_widgets_control_key_provider;
static GtkCssProvider* warble_widgets_control_key_provider = NULL;
static gint WarbleWidgetsControlKeyKeyImage_private_offset;
static gpointer warble_widgets_control_key_key_image_parent_class = NULL;

VALA_EXTERN GType warble_widgets_control_key_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WarbleWidgetsControlKey, g_object_unref)
static GType warble_widgets_control_key_key_image_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WarbleWidgetsControlKeyKeyImage, g_object_unref)
VALA_EXTERN WarbleWidgetsControlKey* warble_widgets_control_key_new_with_text (const gchar* text);
VALA_EXTERN WarbleWidgetsControlKey* warble_widgets_control_key_construct_with_text (GType object_type,
                                                                         const gchar* text);
VALA_EXTERN WarbleWidgetsControlKey* warble_widgets_control_key_new_with_icon (const gchar* icon_name);
VALA_EXTERN WarbleWidgetsControlKey* warble_widgets_control_key_construct_with_icon (GType object_type,
                                                                         const gchar* icon_name);
static void warble_widgets_control_key_update_icon (WarbleWidgetsControlKey* self);
VALA_EXTERN WarbleWidgetsControlKey* warble_widgets_control_key_new (void);
VALA_EXTERN WarbleWidgetsControlKey* warble_widgets_control_key_construct (GType object_type);
VALA_EXTERN const gchar* warble_widgets_control_key_get_text (WarbleWidgetsControlKey* self);
static void warble_widgets_control_key_set_text (WarbleWidgetsControlKey* self,
                                          const gchar* value);
VALA_EXTERN const gchar* warble_widgets_control_key_get_icon_name (WarbleWidgetsControlKey* self);
static void warble_widgets_control_key_set_icon_name (WarbleWidgetsControlKey* self,
                                               const gchar* value);
static WarbleWidgetsControlKeyKeyImage* warble_widgets_control_key_key_image_new (const gchar* text);
static WarbleWidgetsControlKeyKeyImage* warble_widgets_control_key_key_image_construct (GType object_type,
                                                                                 const gchar* text);
static gboolean warble_widgets_control_key_key_image_real_draw (GtkWidget* base,
                                                         cairo_t* ctx);
static const gchar* warble_widgets_control_key_key_image_get_text (WarbleWidgetsControlKeyKeyImage* self);
static void warble_widgets_control_key_key_image_draw_text (WarbleWidgetsControlKeyKeyImage* self,
                                                     cairo_t* ctx);
VALA_EXTERN GType warble_color_palette_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* warble_color_palette_get_value (WarbleColorPalette self);
static gint warble_widgets_control_key_key_image_get_y_offset (WarbleWidgetsControlKeyKeyImage* self);
static void warble_widgets_control_key_key_image_set_text (WarbleWidgetsControlKeyKeyImage* self,
                                                    const gchar* value);
static void warble_widgets_control_key_key_image_set_y_offset (WarbleWidgetsControlKeyKeyImage* self,
                                                        gint value);
static void warble_widgets_control_key_key_image_finalize (GObject * obj);
static GType warble_widgets_control_key_key_image_get_type_once (void);
static void _vala_warble_widgets_control_key_key_image_get_property (GObject * object,
                                                              guint property_id,
                                                              GValue * value,
                                                              GParamSpec * pspec);
static void _vala_warble_widgets_control_key_key_image_set_property (GObject * object,
                                                              guint property_id,
                                                              const GValue * value,
                                                              GParamSpec * pspec);
static GObject * warble_widgets_control_key_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
static gboolean _warble_widgets_control_key___lambda19_ (WarbleWidgetsControlKey* self,
                                                  GdkEventButton* event);
static gboolean __warble_widgets_control_key___lambda19__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                                 GdkEventButton* event,
                                                                                 gpointer self);
static gboolean _warble_widgets_control_key___lambda20_ (WarbleWidgetsControlKey* self);
static gboolean __warble_widgets_control_key___lambda20__gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                   GdkEventButton* event,
                                                                                   gpointer self);
static gboolean _warble_widgets_control_key___lambda21_ (WarbleWidgetsControlKey* self);
static gboolean __warble_widgets_control_key___lambda21__gtk_widget_touch_event (GtkWidget* _sender,
                                                                          GdkEvent* event,
                                                                          gpointer self);
static void warble_widgets_control_key_finalize (GObject * obj);
static GType warble_widgets_control_key_get_type_once (void);
static void _vala_warble_widgets_control_key_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_warble_widgets_control_key_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);

static inline gpointer
warble_widgets_control_key_get_instance_private (WarbleWidgetsControlKey* self)
{
	return G_STRUCT_MEMBER_P (self, WarbleWidgetsControlKey_private_offset);
}

WarbleWidgetsControlKey*
warble_widgets_control_key_construct_with_text (GType object_type,
                                                const gchar* text)
{
	WarbleWidgetsControlKey * self = NULL;
#line 78 "../src/Widgets/ControlKey.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 79 "../src/Widgets/ControlKey.vala"
	self = (WarbleWidgetsControlKey*) g_object_new (object_type, "text", text, "icon-name", NULL, NULL);
#line 78 "../src/Widgets/ControlKey.vala"
	return self;
#line 225 "ControlKey.c"
}

WarbleWidgetsControlKey*
warble_widgets_control_key_new_with_text (const gchar* text)
{
#line 78 "../src/Widgets/ControlKey.vala"
	return warble_widgets_control_key_construct_with_text (WARBLE_WIDGETS_TYPE_CONTROL_KEY, text);
#line 233 "ControlKey.c"
}

WarbleWidgetsControlKey*
warble_widgets_control_key_construct_with_icon (GType object_type,
                                                const gchar* icon_name)
{
	WarbleWidgetsControlKey * self = NULL;
#line 85 "../src/Widgets/ControlKey.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 86 "../src/Widgets/ControlKey.vala"
	self = (WarbleWidgetsControlKey*) g_object_new (object_type, "text", NULL, "icon-name", icon_name, NULL);
#line 85 "../src/Widgets/ControlKey.vala"
	return self;
#line 247 "ControlKey.c"
}

WarbleWidgetsControlKey*
warble_widgets_control_key_new_with_icon (const gchar* icon_name)
{
#line 85 "../src/Widgets/ControlKey.vala"
	return warble_widgets_control_key_construct_with_icon (WARBLE_WIDGETS_TYPE_CONTROL_KEY, icon_name);
#line 255 "ControlKey.c"
}

static void
warble_widgets_control_key_update_icon (WarbleWidgetsControlKey* self)
{
	const gchar* _tmp0_ = NULL;
	WarbleWidgetsControlKeyKeyImage* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GThemedIcon* _tmp4_;
	GThemedIcon* _tmp5_;
#line 142 "../src/Widgets/ControlKey.vala"
	g_return_if_fail (self != NULL);
#line 143 "../src/Widgets/ControlKey.vala"
	if (self->priv->is_pressed) {
#line 143 "../src/Widgets/ControlKey.vala"
		_tmp0_ = ".control-key-pressed";
#line 273 "ControlKey.c"
	} else {
#line 143 "../src/Widgets/ControlKey.vala"
		_tmp0_ = ".control-key";
#line 277 "ControlKey.c"
	}
#line 143 "../src/Widgets/ControlKey.vala"
	_tmp1_ = self->priv->key;
#line 143 "../src/Widgets/ControlKey.vala"
	_tmp2_ = g_strconcat (CONSTANTS_APP_ID, _tmp0_, NULL);
#line 143 "../src/Widgets/ControlKey.vala"
	_tmp3_ = _tmp2_;
#line 143 "../src/Widgets/ControlKey.vala"
	_tmp4_ = (GThemedIcon*) g_themed_icon_new (_tmp3_);
#line 143 "../src/Widgets/ControlKey.vala"
	_tmp5_ = _tmp4_;
#line 143 "../src/Widgets/ControlKey.vala"
	g_object_set ((GtkImage*) _tmp1_, "gicon", (GIcon*) _tmp5_, NULL);
#line 143 "../src/Widgets/ControlKey.vala"
	_g_object_unref0 (_tmp5_);
#line 143 "../src/Widgets/ControlKey.vala"
	_g_free0 (_tmp3_);
#line 295 "ControlKey.c"
}

WarbleWidgetsControlKey*
warble_widgets_control_key_construct (GType object_type)
{
	WarbleWidgetsControlKey * self = NULL;
#line 22 "../src/Widgets/ControlKey.vala"
	self = (WarbleWidgetsControlKey*) g_object_new (object_type, NULL);
#line 22 "../src/Widgets/ControlKey.vala"
	return self;
#line 306 "ControlKey.c"
}

WarbleWidgetsControlKey*
warble_widgets_control_key_new (void)
{
#line 22 "../src/Widgets/ControlKey.vala"
	return warble_widgets_control_key_construct (WARBLE_WIDGETS_TYPE_CONTROL_KEY);
#line 314 "ControlKey.c"
}

const gchar*
warble_widgets_control_key_get_text (WarbleWidgetsControlKey* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 71 "../src/Widgets/ControlKey.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "../src/Widgets/ControlKey.vala"
	_tmp0_ = self->priv->_text;
#line 71 "../src/Widgets/ControlKey.vala"
	result = _tmp0_;
#line 71 "../src/Widgets/ControlKey.vala"
	return result;
#line 330 "ControlKey.c"
}

static void
warble_widgets_control_key_set_text (WarbleWidgetsControlKey* self,
                                     const gchar* value)
{
	gchar* old_value;
#line 71 "../src/Widgets/ControlKey.vala"
	g_return_if_fail (self != NULL);
#line 71 "../src/Widgets/ControlKey.vala"
	old_value = warble_widgets_control_key_get_text (self);
#line 71 "../src/Widgets/ControlKey.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 344 "ControlKey.c"
		gchar* _tmp0_;
#line 71 "../src/Widgets/ControlKey.vala"
		_tmp0_ = g_strdup (value);
#line 71 "../src/Widgets/ControlKey.vala"
		_g_free0 (self->priv->_text);
#line 71 "../src/Widgets/ControlKey.vala"
		self->priv->_text = _tmp0_;
#line 71 "../src/Widgets/ControlKey.vala"
		g_object_notify_by_pspec ((GObject *) self, warble_widgets_control_key_properties[WARBLE_WIDGETS_CONTROL_KEY_TEXT_PROPERTY]);
#line 354 "ControlKey.c"
	}
}

const gchar*
warble_widgets_control_key_get_icon_name (WarbleWidgetsControlKey* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 72 "../src/Widgets/ControlKey.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "../src/Widgets/ControlKey.vala"
	_tmp0_ = self->priv->_icon_name;
#line 72 "../src/Widgets/ControlKey.vala"
	result = _tmp0_;
#line 72 "../src/Widgets/ControlKey.vala"
	return result;
#line 371 "ControlKey.c"
}

static void
warble_widgets_control_key_set_icon_name (WarbleWidgetsControlKey* self,
                                          const gchar* value)
{
	gchar* old_value;
#line 72 "../src/Widgets/ControlKey.vala"
	g_return_if_fail (self != NULL);
#line 72 "../src/Widgets/ControlKey.vala"
	old_value = warble_widgets_control_key_get_icon_name (self);
#line 72 "../src/Widgets/ControlKey.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 385 "ControlKey.c"
		gchar* _tmp0_;
#line 72 "../src/Widgets/ControlKey.vala"
		_tmp0_ = g_strdup (value);
#line 72 "../src/Widgets/ControlKey.vala"
		_g_free0 (self->priv->_icon_name);
#line 72 "../src/Widgets/ControlKey.vala"
		self->priv->_icon_name = _tmp0_;
#line 72 "../src/Widgets/ControlKey.vala"
		g_object_notify_by_pspec ((GObject *) self, warble_widgets_control_key_properties[WARBLE_WIDGETS_CONTROL_KEY_ICON_NAME_PROPERTY]);
#line 395 "ControlKey.c"
	}
}

static inline gpointer
warble_widgets_control_key_key_image_get_instance_private (WarbleWidgetsControlKeyKeyImage* self)
{
	return G_STRUCT_MEMBER_P (self, WarbleWidgetsControlKeyKeyImage_private_offset);
}

static WarbleWidgetsControlKeyKeyImage*
warble_widgets_control_key_key_image_construct (GType object_type,
                                                const gchar* text)
{
	WarbleWidgetsControlKeyKeyImage * self = NULL;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
#line 33 "../src/Widgets/ControlKey.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new (CONSTANTS_APP_ID ".control-key");
#line 33 "../src/Widgets/ControlKey.vala"
	_tmp1_ = _tmp0_;
#line 33 "../src/Widgets/ControlKey.vala"
	self = (WarbleWidgetsControlKeyKeyImage*) g_object_new (object_type, "gicon", _tmp1_, "text", text, "y-offset", 0, "expand", FALSE, "halign", GTK_ALIGN_CENTER, NULL);
#line 33 "../src/Widgets/ControlKey.vala"
	_g_object_unref0 (_tmp1_);
#line 32 "../src/Widgets/ControlKey.vala"
	return self;
#line 422 "ControlKey.c"
}

static WarbleWidgetsControlKeyKeyImage*
warble_widgets_control_key_key_image_new (const gchar* text)
{
#line 32 "../src/Widgets/ControlKey.vala"
	return warble_widgets_control_key_key_image_construct (WARBLE_WIDGETS_CONTROL_KEY_TYPE_KEY_IMAGE, text);
#line 430 "ControlKey.c"
}

static gboolean
warble_widgets_control_key_key_image_real_draw (GtkWidget* base,
                                                cairo_t* ctx)
{
	WarbleWidgetsControlKeyKeyImage * self;
	const gchar* _tmp0_;
	gboolean result;
#line 42 "../src/Widgets/ControlKey.vala"
	self = (WarbleWidgetsControlKeyKeyImage*) base;
#line 42 "../src/Widgets/ControlKey.vala"
	g_return_val_if_fail (ctx != NULL, FALSE);
#line 43 "../src/Widgets/ControlKey.vala"
	GTK_WIDGET_CLASS (warble_widgets_control_key_key_image_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_image_get_type (), GtkImage), ctx);
#line 44 "../src/Widgets/ControlKey.vala"
	cairo_save (ctx);
#line 45 "../src/Widgets/ControlKey.vala"
	_tmp0_ = self->priv->_text;
#line 45 "../src/Widgets/ControlKey.vala"
	if (_tmp0_ != NULL) {
#line 46 "../src/Widgets/ControlKey.vala"
		warble_widgets_control_key_key_image_draw_text (self, ctx);
#line 454 "ControlKey.c"
	}
#line 48 "../src/Widgets/ControlKey.vala"
	cairo_restore (ctx);
#line 49 "../src/Widgets/ControlKey.vala"
	result = FALSE;
#line 49 "../src/Widgets/ControlKey.vala"
	return result;
#line 462 "ControlKey.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1578 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1579 "glib-2.0.vapi"
	result = self;
#line 1579 "glib-2.0.vapi"
	return result;
#line 475 "ControlKey.c"
}

static void
warble_widgets_control_key_key_image_draw_text (WarbleWidgetsControlKeyKeyImage* self,
                                                cairo_t* ctx)
{
	GraniteDrawingColor* color = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GraniteDrawingColor* _tmp2_;
	GraniteDrawingColor* _tmp3_;
	cairo_text_extents_t extents = {0};
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	cairo_text_extents_t _tmp6_ = {0};
	gdouble x = 0.0;
	cairo_text_extents_t _tmp7_;
	cairo_text_extents_t _tmp8_;
	gdouble y = 0.0;
	cairo_text_extents_t _tmp9_;
	cairo_text_extents_t _tmp10_;
	gint _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
#line 52 "../src/Widgets/ControlKey.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/Widgets/ControlKey.vala"
	g_return_if_fail (ctx != NULL);
#line 53 "../src/Widgets/ControlKey.vala"
	_tmp0_ = warble_color_palette_get_value (WARBLE_COLOR_PALETTE_TEXT_COLOR);
#line 53 "../src/Widgets/ControlKey.vala"
	_tmp1_ = _tmp0_;
#line 53 "../src/Widgets/ControlKey.vala"
	_tmp2_ = granite_drawing_color_new_from_string (_tmp1_);
#line 53 "../src/Widgets/ControlKey.vala"
	_tmp3_ = _tmp2_;
#line 53 "../src/Widgets/ControlKey.vala"
	_g_free0 (_tmp1_);
#line 53 "../src/Widgets/ControlKey.vala"
	color = _tmp3_;
#line 54 "../src/Widgets/ControlKey.vala"
	cairo_set_source_rgb (ctx, color->R, color->G, color->B);
#line 56 "../src/Widgets/ControlKey.vala"
	cairo_select_font_face (ctx, "Inter", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
#line 57 "../src/Widgets/ControlKey.vala"
	cairo_set_font_size (ctx, (gdouble) 13);
#line 60 "../src/Widgets/ControlKey.vala"
	_tmp4_ = self->priv->_text;
#line 60 "../src/Widgets/ControlKey.vala"
	_tmp5_ = string_to_string (_tmp4_);
#line 60 "../src/Widgets/ControlKey.vala"
	cairo_text_extents (ctx, _tmp5_, &_tmp6_);
#line 60 "../src/Widgets/ControlKey.vala"
	extents = _tmp6_;
#line 61 "../src/Widgets/ControlKey.vala"
	_tmp7_ = extents;
#line 61 "../src/Widgets/ControlKey.vala"
	_tmp8_ = extents;
#line 61 "../src/Widgets/ControlKey.vala"
	x = (WARBLE_WIDGETS_CONTROL_KEY_KEY_IMAGE_WIDTH / 2) - ((_tmp7_.width / 2) + _tmp8_.x_bearing);
#line 62 "../src/Widgets/ControlKey.vala"
	_tmp9_ = extents;
#line 62 "../src/Widgets/ControlKey.vala"
	_tmp10_ = extents;
#line 62 "../src/Widgets/ControlKey.vala"
	_tmp11_ = self->priv->_y_offset;
#line 62 "../src/Widgets/ControlKey.vala"
	y = ((WARBLE_WIDGETS_CONTROL_KEY_KEY_IMAGE_HEIGHT / 2) - ((_tmp9_.height / 2) + _tmp10_.y_bearing)) + _tmp11_;
#line 63 "../src/Widgets/ControlKey.vala"
	cairo_move_to (ctx, x, y);
#line 64 "../src/Widgets/ControlKey.vala"
	_tmp12_ = self->priv->_text;
#line 64 "../src/Widgets/ControlKey.vala"
	_tmp13_ = string_to_string (_tmp12_);
#line 64 "../src/Widgets/ControlKey.vala"
	cairo_show_text (ctx, _tmp13_);
#line 52 "../src/Widgets/ControlKey.vala"
	_g_object_unref0 (color);
#line 554 "ControlKey.c"
}

static const gchar*
warble_widgets_control_key_key_image_get_text (WarbleWidgetsControlKeyKeyImage* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 29 "../src/Widgets/ControlKey.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/Widgets/ControlKey.vala"
	_tmp0_ = self->priv->_text;
#line 29 "../src/Widgets/ControlKey.vala"
	result = _tmp0_;
#line 29 "../src/Widgets/ControlKey.vala"
	return result;
#line 570 "ControlKey.c"
}

static void
warble_widgets_control_key_key_image_set_text (WarbleWidgetsControlKeyKeyImage* self,
                                               const gchar* value)
{
	gchar* old_value;
#line 29 "../src/Widgets/ControlKey.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Widgets/ControlKey.vala"
	old_value = warble_widgets_control_key_key_image_get_text (self);
#line 29 "../src/Widgets/ControlKey.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 584 "ControlKey.c"
		gchar* _tmp0_;
#line 29 "../src/Widgets/ControlKey.vala"
		_tmp0_ = g_strdup (value);
#line 29 "../src/Widgets/ControlKey.vala"
		_g_free0 (self->priv->_text);
#line 29 "../src/Widgets/ControlKey.vala"
		self->priv->_text = _tmp0_;
#line 29 "../src/Widgets/ControlKey.vala"
		g_object_notify_by_pspec ((GObject *) self, warble_widgets_control_key_key_image_properties[WARBLE_WIDGETS_CONTROL_KEY_KEY_IMAGE_TEXT_PROPERTY]);
#line 594 "ControlKey.c"
	}
}

static gint
warble_widgets_control_key_key_image_get_y_offset (WarbleWidgetsControlKeyKeyImage* self)
{
	gint result;
#line 30 "../src/Widgets/ControlKey.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 30 "../src/Widgets/ControlKey.vala"
	result = self->priv->_y_offset;
#line 30 "../src/Widgets/ControlKey.vala"
	return result;
#line 608 "ControlKey.c"
}

static void
warble_widgets_control_key_key_image_set_y_offset (WarbleWidgetsControlKeyKeyImage* self,
                                                   gint value)
{
	gint old_value;
#line 30 "../src/Widgets/ControlKey.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Widgets/ControlKey.vala"
	old_value = warble_widgets_control_key_key_image_get_y_offset (self);
#line 30 "../src/Widgets/ControlKey.vala"
	if (old_value != value) {
#line 30 "../src/Widgets/ControlKey.vala"
		self->priv->_y_offset = value;
#line 30 "../src/Widgets/ControlKey.vala"
		g_object_notify_by_pspec ((GObject *) self, warble_widgets_control_key_key_image_properties[WARBLE_WIDGETS_CONTROL_KEY_KEY_IMAGE_Y_OFFSET_PROPERTY]);
#line 626 "ControlKey.c"
	}
}

static void
warble_widgets_control_key_key_image_class_init (WarbleWidgetsControlKeyKeyImageClass * klass,
                                                 gpointer klass_data)
{
#line 24 "../src/Widgets/ControlKey.vala"
	warble_widgets_control_key_key_image_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/Widgets/ControlKey.vala"
	g_type_class_adjust_private_offset (klass, &WarbleWidgetsControlKeyKeyImage_private_offset);
#line 24 "../src/Widgets/ControlKey.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) warble_widgets_control_key_key_image_real_draw;
#line 24 "../src/Widgets/ControlKey.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_warble_widgets_control_key_key_image_get_property;
#line 24 "../src/Widgets/ControlKey.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_warble_widgets_control_key_key_image_set_property;
#line 24 "../src/Widgets/ControlKey.vala"
	G_OBJECT_CLASS (klass)->finalize = warble_widgets_control_key_key_image_finalize;
#line 24 "../src/Widgets/ControlKey.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARBLE_WIDGETS_CONTROL_KEY_KEY_IMAGE_TEXT_PROPERTY, warble_widgets_control_key_key_image_properties[WARBLE_WIDGETS_CONTROL_KEY_KEY_IMAGE_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 24 "../src/Widgets/ControlKey.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARBLE_WIDGETS_CONTROL_KEY_KEY_IMAGE_Y_OFFSET_PROPERTY, warble_widgets_control_key_key_image_properties[WARBLE_WIDGETS_CONTROL_KEY_KEY_IMAGE_Y_OFFSET_PROPERTY] = g_param_spec_int ("y-offset", "y-offset", "y-offset", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 650 "ControlKey.c"
}

static void
warble_widgets_control_key_key_image_instance_init (WarbleWidgetsControlKeyKeyImage * self,
                                                    gpointer klass)
{
#line 24 "../src/Widgets/ControlKey.vala"
	self->priv = warble_widgets_control_key_key_image_get_instance_private (self);
#line 659 "ControlKey.c"
}

static void
warble_widgets_control_key_key_image_finalize (GObject * obj)
{
	WarbleWidgetsControlKeyKeyImage * self;
#line 24 "../src/Widgets/ControlKey.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WARBLE_WIDGETS_CONTROL_KEY_TYPE_KEY_IMAGE, WarbleWidgetsControlKeyKeyImage);
#line 29 "../src/Widgets/ControlKey.vala"
	_g_free0 (self->priv->_text);
#line 24 "../src/Widgets/ControlKey.vala"
	G_OBJECT_CLASS (warble_widgets_control_key_key_image_parent_class)->finalize (obj);
#line 672 "ControlKey.c"
}

static GType
warble_widgets_control_key_key_image_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WarbleWidgetsControlKeyKeyImageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) warble_widgets_control_key_key_image_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WarbleWidgetsControlKeyKeyImage), 0, (GInstanceInitFunc) warble_widgets_control_key_key_image_instance_init, NULL };
	GType warble_widgets_control_key_key_image_type_id;
	warble_widgets_control_key_key_image_type_id = g_type_register_static (gtk_image_get_type (), "WarbleWidgetsControlKeyKeyImage", &g_define_type_info, 0);
	WarbleWidgetsControlKeyKeyImage_private_offset = g_type_add_instance_private (warble_widgets_control_key_key_image_type_id, sizeof (WarbleWidgetsControlKeyKeyImagePrivate));
	return warble_widgets_control_key_key_image_type_id;
}

static GType
warble_widgets_control_key_key_image_get_type (void)
{
	static volatile gsize warble_widgets_control_key_key_image_type_id__once = 0;
	if (g_once_init_enter (&warble_widgets_control_key_key_image_type_id__once)) {
		GType warble_widgets_control_key_key_image_type_id;
		warble_widgets_control_key_key_image_type_id = warble_widgets_control_key_key_image_get_type_once ();
		g_once_init_leave (&warble_widgets_control_key_key_image_type_id__once, warble_widgets_control_key_key_image_type_id);
	}
	return warble_widgets_control_key_key_image_type_id__once;
}

static void
_vala_warble_widgets_control_key_key_image_get_property (GObject * object,
                                                         guint property_id,
                                                         GValue * value,
                                                         GParamSpec * pspec)
{
	WarbleWidgetsControlKeyKeyImage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WARBLE_WIDGETS_CONTROL_KEY_TYPE_KEY_IMAGE, WarbleWidgetsControlKeyKeyImage);
#line 24 "../src/Widgets/ControlKey.vala"
	switch (property_id) {
#line 24 "../src/Widgets/ControlKey.vala"
		case WARBLE_WIDGETS_CONTROL_KEY_KEY_IMAGE_TEXT_PROPERTY:
#line 24 "../src/Widgets/ControlKey.vala"
		g_value_set_string (value, warble_widgets_control_key_key_image_get_text (self));
#line 24 "../src/Widgets/ControlKey.vala"
		break;
#line 24 "../src/Widgets/ControlKey.vala"
		case WARBLE_WIDGETS_CONTROL_KEY_KEY_IMAGE_Y_OFFSET_PROPERTY:
#line 24 "../src/Widgets/ControlKey.vala"
		g_value_set_int (value, warble_widgets_control_key_key_image_get_y_offset (self));
#line 24 "../src/Widgets/ControlKey.vala"
		break;
#line 719 "ControlKey.c"
		default:
#line 24 "../src/Widgets/ControlKey.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/Widgets/ControlKey.vala"
		break;
#line 725 "ControlKey.c"
	}
}

static void
_vala_warble_widgets_control_key_key_image_set_property (GObject * object,
                                                         guint property_id,
                                                         const GValue * value,
                                                         GParamSpec * pspec)
{
	WarbleWidgetsControlKeyKeyImage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WARBLE_WIDGETS_CONTROL_KEY_TYPE_KEY_IMAGE, WarbleWidgetsControlKeyKeyImage);
#line 24 "../src/Widgets/ControlKey.vala"
	switch (property_id) {
#line 24 "../src/Widgets/ControlKey.vala"
		case WARBLE_WIDGETS_CONTROL_KEY_KEY_IMAGE_TEXT_PROPERTY:
#line 24 "../src/Widgets/ControlKey.vala"
		warble_widgets_control_key_key_image_set_text (self, g_value_get_string (value));
#line 24 "../src/Widgets/ControlKey.vala"
		break;
#line 24 "../src/Widgets/ControlKey.vala"
		case WARBLE_WIDGETS_CONTROL_KEY_KEY_IMAGE_Y_OFFSET_PROPERTY:
#line 24 "../src/Widgets/ControlKey.vala"
		warble_widgets_control_key_key_image_set_y_offset (self, g_value_get_int (value));
#line 24 "../src/Widgets/ControlKey.vala"
		break;
#line 751 "ControlKey.c"
		default:
#line 24 "../src/Widgets/ControlKey.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/Widgets/ControlKey.vala"
		break;
#line 757 "ControlKey.c"
	}
}

static gboolean
_warble_widgets_control_key___lambda19_ (WarbleWidgetsControlKey* self,
                                         GdkEventButton* event)
{
	WarbleWidgetsControlKeyKeyImage* _tmp0_;
	GtkImage* _tmp1_;
	gboolean result;
#line 114 "../src/Widgets/ControlKey.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 116 "../src/Widgets/ControlKey.vala"
	if (event->type != GDK_BUTTON_PRESS) {
#line 117 "../src/Widgets/ControlKey.vala"
		result = FALSE;
#line 117 "../src/Widgets/ControlKey.vala"
		return result;
#line 776 "ControlKey.c"
	}
#line 119 "../src/Widgets/ControlKey.vala"
	self->priv->is_pressed = TRUE;
#line 120 "../src/Widgets/ControlKey.vala"
	_tmp0_ = self->priv->key;
#line 120 "../src/Widgets/ControlKey.vala"
	warble_widgets_control_key_key_image_set_y_offset (_tmp0_, 2);
#line 121 "../src/Widgets/ControlKey.vala"
	_tmp1_ = self->priv->overlay_icon;
#line 121 "../src/Widgets/ControlKey.vala"
	if (_tmp1_ != NULL) {
#line 788 "ControlKey.c"
		GtkImage* _tmp2_;
#line 122 "../src/Widgets/ControlKey.vala"
		_tmp2_ = self->priv->overlay_icon;
#line 122 "../src/Widgets/ControlKey.vala"
		gtk_widget_set_margin_top ((GtkWidget*) _tmp2_, 2);
#line 794 "ControlKey.c"
	}
#line 124 "../src/Widgets/ControlKey.vala"
	warble_widgets_control_key_update_icon (self);
#line 125 "../src/Widgets/ControlKey.vala"
	g_signal_emit (self, warble_widgets_control_key_signals[WARBLE_WIDGETS_CONTROL_KEY_CLICKED_SIGNAL], 0);
#line 800 "ControlKey.c"
}

static gboolean
__warble_widgets_control_key___lambda19__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                        GdkEventButton* event,
                                                                        gpointer self)
{
	gboolean result;
	result = _warble_widgets_control_key___lambda19_ ((WarbleWidgetsControlKey*) self, event);
#line 114 "../src/Widgets/ControlKey.vala"
	return result;
#line 812 "ControlKey.c"
}

static gboolean
_warble_widgets_control_key___lambda20_ (WarbleWidgetsControlKey* self)
{
	WarbleWidgetsControlKeyKeyImage* _tmp0_;
	GtkImage* _tmp1_;
#line 128 "../src/Widgets/ControlKey.vala"
	self->priv->is_pressed = FALSE;
#line 129 "../src/Widgets/ControlKey.vala"
	_tmp0_ = self->priv->key;
#line 129 "../src/Widgets/ControlKey.vala"
	warble_widgets_control_key_key_image_set_y_offset (_tmp0_, 0);
#line 130 "../src/Widgets/ControlKey.vala"
	_tmp1_ = self->priv->overlay_icon;
#line 130 "../src/Widgets/ControlKey.vala"
	if (_tmp1_ != NULL) {
#line 830 "ControlKey.c"
		GtkImage* _tmp2_;
#line 131 "../src/Widgets/ControlKey.vala"
		_tmp2_ = self->priv->overlay_icon;
#line 131 "../src/Widgets/ControlKey.vala"
		gtk_widget_set_margin_top ((GtkWidget*) _tmp2_, 0);
#line 836 "ControlKey.c"
	}
#line 133 "../src/Widgets/ControlKey.vala"
	warble_widgets_control_key_update_icon (self);
#line 840 "ControlKey.c"
}

static gboolean
__warble_widgets_control_key___lambda20__gtk_widget_button_release_event (GtkWidget* _sender,
                                                                          GdkEventButton* event,
                                                                          gpointer self)
{
	gboolean result;
	result = _warble_widgets_control_key___lambda20_ ((WarbleWidgetsControlKey*) self);
#line 127 "../src/Widgets/ControlKey.vala"
	return result;
#line 852 "ControlKey.c"
}

static gboolean
_warble_widgets_control_key___lambda21_ (WarbleWidgetsControlKey* self)
{
#line 138 "../src/Widgets/ControlKey.vala"
	g_signal_emit (self, warble_widgets_control_key_signals[WARBLE_WIDGETS_CONTROL_KEY_CLICKED_SIGNAL], 0);
#line 860 "ControlKey.c"
}

static gboolean
__warble_widgets_control_key___lambda21__gtk_widget_touch_event (GtkWidget* _sender,
                                                                 GdkEvent* event,
                                                                 gpointer self)
{
	gboolean result;
	result = _warble_widgets_control_key___lambda21_ ((WarbleWidgetsControlKey*) self);
#line 135 "../src/Widgets/ControlKey.vala"
	return result;
#line 872 "ControlKey.c"
}

static GObject *
warble_widgets_control_key_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WarbleWidgetsControlKey * self;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp0_;
	const gchar* _tmp1_;
	WarbleWidgetsControlKeyKeyImage* _tmp2_;
	GtkOverlay* _tmp3_;
	WarbleWidgetsControlKeyKeyImage* _tmp4_;
	const gchar* _tmp5_;
	GtkOverlay* _tmp16_;
#line 97 "../src/Widgets/ControlKey.vala"
	parent_class = G_OBJECT_CLASS (warble_widgets_control_key_parent_class);
#line 97 "../src/Widgets/ControlKey.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 97 "../src/Widgets/ControlKey.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WARBLE_WIDGETS_TYPE_CONTROL_KEY, WarbleWidgetsControlKey);
#line 98 "../src/Widgets/ControlKey.vala"
	_tmp0_ = (GtkOverlay*) gtk_overlay_new ();
#line 98 "../src/Widgets/ControlKey.vala"
	g_object_ref_sink (_tmp0_);
#line 98 "../src/Widgets/ControlKey.vala"
	overlay = _tmp0_;
#line 99 "../src/Widgets/ControlKey.vala"
	_tmp1_ = self->priv->_text;
#line 99 "../src/Widgets/ControlKey.vala"
	_tmp2_ = warble_widgets_control_key_key_image_new (_tmp1_);
#line 99 "../src/Widgets/ControlKey.vala"
	g_object_ref_sink (_tmp2_);
#line 99 "../src/Widgets/ControlKey.vala"
	_g_object_unref0 (self->priv->key);
#line 99 "../src/Widgets/ControlKey.vala"
	self->priv->key = _tmp2_;
#line 100 "../src/Widgets/ControlKey.vala"
	_tmp3_ = overlay;
#line 100 "../src/Widgets/ControlKey.vala"
	_tmp4_ = self->priv->key;
#line 100 "../src/Widgets/ControlKey.vala"
	gtk_container_add ((GtkContainer*) _tmp3_, (GtkWidget*) _tmp4_);
#line 101 "../src/Widgets/ControlKey.vala"
	_tmp5_ = self->priv->_icon_name;
#line 101 "../src/Widgets/ControlKey.vala"
	if (_tmp5_ != NULL) {
#line 923 "ControlKey.c"
		const gchar* _tmp6_;
		GThemedIcon* _tmp7_;
		GtkImage* _tmp8_ = NULL;
		GtkStyleContext* style_context = NULL;
		GtkImage* _tmp9_;
		GtkStyleContext* _tmp10_;
		GtkStyleContext* _tmp11_;
		GtkStyleContext* _tmp12_;
		GtkCssProvider* _tmp13_;
		GtkOverlay* _tmp14_;
		GtkImage* _tmp15_;
#line 102 "../src/Widgets/ControlKey.vala"
		_tmp6_ = self->priv->_icon_name;
#line 102 "../src/Widgets/ControlKey.vala"
		_tmp7_ = (GThemedIcon*) g_themed_icon_new (_tmp6_);
#line 102 "../src/Widgets/ControlKey.vala"
		_tmp8_ = (GtkImage*) gtk_image_new ();
#line 102 "../src/Widgets/ControlKey.vala"
		g_object_set (_tmp8_, "gicon", (GIcon*) _tmp7_, NULL);
#line 102 "../src/Widgets/ControlKey.vala"
		_g_object_unref0 (_tmp7_);
#line 102 "../src/Widgets/ControlKey.vala"
		g_object_ref_sink (_tmp8_);
#line 102 "../src/Widgets/ControlKey.vala"
		_g_object_unref0 (self->priv->overlay_icon);
#line 102 "../src/Widgets/ControlKey.vala"
		self->priv->overlay_icon = _tmp8_;
#line 105 "../src/Widgets/ControlKey.vala"
		_tmp9_ = self->priv->overlay_icon;
#line 105 "../src/Widgets/ControlKey.vala"
		_tmp10_ = gtk_widget_get_style_context ((GtkWidget*) _tmp9_);
#line 105 "../src/Widgets/ControlKey.vala"
		style_context = _tmp10_;
#line 106 "../src/Widgets/ControlKey.vala"
		_tmp11_ = style_context;
#line 106 "../src/Widgets/ControlKey.vala"
		gtk_style_context_add_class (_tmp11_, "control-key-overlay-icon");
#line 107 "../src/Widgets/ControlKey.vala"
		_tmp12_ = style_context;
#line 107 "../src/Widgets/ControlKey.vala"
		_tmp13_ = warble_widgets_control_key_provider;
#line 107 "../src/Widgets/ControlKey.vala"
		gtk_style_context_add_provider (_tmp12_, (GtkStyleProvider*) _tmp13_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 108 "../src/Widgets/ControlKey.vala"
		_tmp14_ = overlay;
#line 108 "../src/Widgets/ControlKey.vala"
		_tmp15_ = self->priv->overlay_icon;
#line 108 "../src/Widgets/ControlKey.vala"
		gtk_overlay_add_overlay (_tmp14_, (GtkWidget*) _tmp15_);
#line 973 "ControlKey.c"
	}
#line 110 "../src/Widgets/ControlKey.vala"
	_tmp16_ = overlay;
#line 110 "../src/Widgets/ControlKey.vala"
	g_object_set ((GtkContainer*) self, "child", (GtkWidget*) _tmp16_, NULL);
#line 113 "../src/Widgets/ControlKey.vala"
	gtk_widget_add_events ((GtkWidget*) self, (gint) ((GDK_BUTTON_PRESS_MASK | GDK_TOUCH_MASK) | GDK_BUTTON_RELEASE_MASK));
#line 114 "../src/Widgets/ControlKey.vala"
	g_signal_connect_object ((GtkWidget*) self, "button-press-event", (GCallback) __warble_widgets_control_key___lambda19__gtk_widget_button_press_event, self, 0);
#line 127 "../src/Widgets/ControlKey.vala"
	g_signal_connect_object ((GtkWidget*) self, "button-release-event", (GCallback) __warble_widgets_control_key___lambda20__gtk_widget_button_release_event, self, 0);
#line 135 "../src/Widgets/ControlKey.vala"
	g_signal_connect_object ((GtkWidget*) self, "touch-event", (GCallback) __warble_widgets_control_key___lambda21__gtk_widget_touch_event, self, 0);
#line 97 "../src/Widgets/ControlKey.vala"
	_g_object_unref0 (overlay);
#line 97 "../src/Widgets/ControlKey.vala"
	return obj;
#line 991 "ControlKey.c"
}

static void
warble_widgets_control_key_class_init (WarbleWidgetsControlKeyClass * klass,
                                       gpointer klass_data)
{
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
#line 22 "../src/Widgets/ControlKey.vala"
	warble_widgets_control_key_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Widgets/ControlKey.vala"
	g_type_class_adjust_private_offset (klass, &WarbleWidgetsControlKey_private_offset);
#line 22 "../src/Widgets/ControlKey.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_warble_widgets_control_key_get_property;
#line 22 "../src/Widgets/ControlKey.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_warble_widgets_control_key_set_property;
#line 22 "../src/Widgets/ControlKey.vala"
	G_OBJECT_CLASS (klass)->constructor = warble_widgets_control_key_constructor;
#line 22 "../src/Widgets/ControlKey.vala"
	G_OBJECT_CLASS (klass)->finalize = warble_widgets_control_key_finalize;
#line 22 "../src/Widgets/ControlKey.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARBLE_WIDGETS_CONTROL_KEY_TEXT_PROPERTY, warble_widgets_control_key_properties[WARBLE_WIDGETS_CONTROL_KEY_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Widgets/ControlKey.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARBLE_WIDGETS_CONTROL_KEY_ICON_NAME_PROPERTY, warble_widgets_control_key_properties[WARBLE_WIDGETS_CONTROL_KEY_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Widgets/ControlKey.vala"
	warble_widgets_control_key_signals[WARBLE_WIDGETS_CONTROL_KEY_CLICKED_SIGNAL] = g_signal_new ("clicked", WARBLE_WIDGETS_TYPE_CONTROL_KEY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 93 "../src/Widgets/ControlKey.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 93 "../src/Widgets/ControlKey.vala"
	_g_object_unref0 (warble_widgets_control_key_provider);
#line 93 "../src/Widgets/ControlKey.vala"
	warble_widgets_control_key_provider = _tmp0_;
#line 94 "../src/Widgets/ControlKey.vala"
	_tmp1_ = warble_widgets_control_key_provider;
#line 94 "../src/Widgets/ControlKey.vala"
	gtk_css_provider_load_from_resource (_tmp1_, "com/github/avojak/warble/ControlKeyOverlayIcon.css");
#line 1028 "ControlKey.c"
}

static void
warble_widgets_control_key_instance_init (WarbleWidgetsControlKey * self,
                                          gpointer klass)
{
#line 22 "../src/Widgets/ControlKey.vala"
	self->priv = warble_widgets_control_key_get_instance_private (self);
#line 76 "../src/Widgets/ControlKey.vala"
	self->priv->is_pressed = FALSE;
#line 1039 "ControlKey.c"
}

static void
warble_widgets_control_key_finalize (GObject * obj)
{
	WarbleWidgetsControlKey * self;
#line 22 "../src/Widgets/ControlKey.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WARBLE_WIDGETS_TYPE_CONTROL_KEY, WarbleWidgetsControlKey);
#line 71 "../src/Widgets/ControlKey.vala"
	_g_free0 (self->priv->_text);
#line 72 "../src/Widgets/ControlKey.vala"
	_g_free0 (self->priv->_icon_name);
#line 74 "../src/Widgets/ControlKey.vala"
	_g_object_unref0 (self->priv->key);
#line 75 "../src/Widgets/ControlKey.vala"
	_g_object_unref0 (self->priv->overlay_icon);
#line 22 "../src/Widgets/ControlKey.vala"
	G_OBJECT_CLASS (warble_widgets_control_key_parent_class)->finalize (obj);
#line 1058 "ControlKey.c"
}

static GType
warble_widgets_control_key_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WarbleWidgetsControlKeyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) warble_widgets_control_key_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WarbleWidgetsControlKey), 0, (GInstanceInitFunc) warble_widgets_control_key_instance_init, NULL };
	GType warble_widgets_control_key_type_id;
	warble_widgets_control_key_type_id = g_type_register_static (gtk_event_box_get_type (), "WarbleWidgetsControlKey", &g_define_type_info, 0);
	WarbleWidgetsControlKey_private_offset = g_type_add_instance_private (warble_widgets_control_key_type_id, sizeof (WarbleWidgetsControlKeyPrivate));
	return warble_widgets_control_key_type_id;
}

GType
warble_widgets_control_key_get_type (void)
{
	static volatile gsize warble_widgets_control_key_type_id__once = 0;
	if (g_once_init_enter (&warble_widgets_control_key_type_id__once)) {
		GType warble_widgets_control_key_type_id;
		warble_widgets_control_key_type_id = warble_widgets_control_key_get_type_once ();
		g_once_init_leave (&warble_widgets_control_key_type_id__once, warble_widgets_control_key_type_id);
	}
	return warble_widgets_control_key_type_id__once;
}

static void
_vala_warble_widgets_control_key_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	WarbleWidgetsControlKey * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WARBLE_WIDGETS_TYPE_CONTROL_KEY, WarbleWidgetsControlKey);
#line 22 "../src/Widgets/ControlKey.vala"
	switch (property_id) {
#line 22 "../src/Widgets/ControlKey.vala"
		case WARBLE_WIDGETS_CONTROL_KEY_TEXT_PROPERTY:
#line 22 "../src/Widgets/ControlKey.vala"
		g_value_set_string (value, warble_widgets_control_key_get_text (self));
#line 22 "../src/Widgets/ControlKey.vala"
		break;
#line 22 "../src/Widgets/ControlKey.vala"
		case WARBLE_WIDGETS_CONTROL_KEY_ICON_NAME_PROPERTY:
#line 22 "../src/Widgets/ControlKey.vala"
		g_value_set_string (value, warble_widgets_control_key_get_icon_name (self));
#line 22 "../src/Widgets/ControlKey.vala"
		break;
#line 1105 "ControlKey.c"
		default:
#line 22 "../src/Widgets/ControlKey.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/ControlKey.vala"
		break;
#line 1111 "ControlKey.c"
	}
}

static void
_vala_warble_widgets_control_key_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	WarbleWidgetsControlKey * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WARBLE_WIDGETS_TYPE_CONTROL_KEY, WarbleWidgetsControlKey);
#line 22 "../src/Widgets/ControlKey.vala"
	switch (property_id) {
#line 22 "../src/Widgets/ControlKey.vala"
		case WARBLE_WIDGETS_CONTROL_KEY_TEXT_PROPERTY:
#line 22 "../src/Widgets/ControlKey.vala"
		warble_widgets_control_key_set_text (self, g_value_get_string (value));
#line 22 "../src/Widgets/ControlKey.vala"
		break;
#line 22 "../src/Widgets/ControlKey.vala"
		case WARBLE_WIDGETS_CONTROL_KEY_ICON_NAME_PROPERTY:
#line 22 "../src/Widgets/ControlKey.vala"
		warble_widgets_control_key_set_icon_name (self, g_value_get_string (value));
#line 22 "../src/Widgets/ControlKey.vala"
		break;
#line 1137 "ControlKey.c"
		default:
#line 22 "../src/Widgets/ControlKey.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/ControlKey.vala"
		break;
#line 1143 "ControlKey.c"
	}
}

